import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.text.*;
import java.lang.*;
import java.io.*;
import java.net.URL;

//--------------------------------------------------------------------//
//   3D_W ver 1.1					      //
//--------------------------------------------------------------------//
// NXꗗ
//  class FileFormatException t@CO
//  class Dungeon3D           C
//  class dungeonPanel        _W\
//  class ControlPanel        Rg[pl
//  class Ddata               _Wf[^
//  class Floor               Kwf[^
//  class MapGrid             }bvP}X̃f[^
//  class Event               CxgNX
//  class draw2D              Q}bv\	
//  class draw3D              R}bv\	
//--------------------------------------------------------------------//

//--------------------------------------------------------------------//
// t@CO
class FileFormatException extends Exception {
  public FileFormatException(String s) {
    super(s);
  }
}

//--------------------------------------------------------------------//
// C
public class Dungeon3D extends Applet{
  dungeonPanel dpanel;
  ControlPanel cont;
  String name;

//--------------------------------------------------------------------//
  public void init(){
// f[^t@C
    URL base=getDocumentBase();
    name=getParameter("mapdata");
    if (name==null) name="sumple.dgn";
    setLayout(new BorderLayout());
    dpanel=new dungeonPanel(base,name);
    cont=new ControlPanel(dpanel);
    add("Center",dpanel);
    add("East",cont);
  }

//--------------------------------------------------------------------//
  public void destroy(){
    remove(dpanel);
    remove(cont);
  }
}

//--------------------------------------------------------------------//
// _W\
class dungeonPanel extends Panel
  implements MouseListener,KeyListener{
    Ddata dd;
    String message;
    int mapView=0;                 // \ݒ
    int eventtype=0;               // Cxg
    boolean waitsw=true;           // ҋ@ԃXCb`
    int fx,fy,fxi,fyi,x0,y0;       // n}\TCYEʒu
    int depth=6;                   // \s
    private Image bgImage;         // _uobt@OpC[W
    private Graphics bg;
    private boolean clrsw=false;   // ҋ@ԃXCb`

//--------------------------------------------------------------------//
  public dungeonPanel(URL base,String name){
    int i;

    getData(base,name);
    setBackground(Color.black);
    addMouseListener(this);
    addKeyListener(this);
  }

//--------------------------------------------------------------------//
  void getData(URL base,String name){
// f[^ǂݍ
    int i;
    InputStream is=null;

    message=null;
    try{
      is=new URL(base,name).openStream();
      dd=new Ddata(is);
    }
    catch(Exception e){
      message=e.toString();
    }
    try {
      if (is!=null) is.close();
    }
    catch(Exception e) {
    }
  }

//--------------------------------------------------------------------//
  public void mouseClicked(MouseEvent e){
  }

//--------------------------------------------------------------------//
  public void mousePressed(MouseEvent e){
    int mousex,mousey;
    mousex=e.getX();
    mousey=e.getY();
    e.consume();

    switch(dd.eventYN(eventtype,mousex,mousey)){
      case 0:
      	eventOff();
      	break;
      case 1:
      	eventOn();
      	break;
    }
  }

//--------------------------------------------------------------------//
  public void mouseReleased(MouseEvent e){
  }

//--------------------------------------------------------------------//
  public void mouseEntered(MouseEvent e){
  }

//--------------------------------------------------------------------//
  public void mouseExited(MouseEvent e){
  }

//--------------------------------------------------------------------//
  public void keyPressed(KeyEvent e){
  }

//--------------------------------------------------------------------//
  public void keyReleased(KeyEvent e){
  }

//--------------------------------------------------------------------//
  public void keyTyped(KeyEvent e){
    char keyin;

    keyin=(char)e.getKeyChar();
    switch(keyin){
      case '2':
      	turnBack();
      	break;
      case '4':
      	turnLeft();
      	break;
      case '5':
      	setView(1-mapView);
      	break;
      case '6':
      	turnRight();
      	break;
      case '8':
      	goAhead();
      	break;
      case 'c':
      	setView(1-mapView);
      	break;
      case 'n':
      	eventOff();
      	break;
      case 'y':
      	eventOn();
      	break;
      case 'C':
      	setView(1-mapView);
      	break;
      case 'N':
      	eventOff();
      	break;
      case 'Y':
      	eventOn();
      	break;
    }
  }

//--------------------------------------------------------------------//
  void goAhead(){
// OɈړ
    if(mapView==0 && !waitsw){
      eventtype=dd.goAhead();
      if(eventtype!=0){
      	waitsw=true;
      }
      repaint();
    }
  }

//--------------------------------------------------------------------//
  void turnRight(){
// E
    if(mapView==0 && !waitsw){
      dd.turnRight();
      repaint();
    }
  }

//--------------------------------------------------------------------//
  void turnLeft(){
// 
    if(mapView==0 && !waitsw){
      dd.turnLeft();
      repaint();
    }
  }

//--------------------------------------------------------------------//
  void turnBack(){
// 
    if(mapView==0 && !waitsw){
      dd.turnBack();
      repaint();
    }
  }

//--------------------------------------------------------------------//
  void eventOn(){
// Cxgs
    if(waitsw){
      waitsw=false;
      clrsw=true;
      dd.eventAction(eventtype);
      repaint();
    }
  }

//--------------------------------------------------------------------//
  void eventOff(){
// CxgLZ
    if(waitsw){
      waitsw=false;
      repaint();
    }
  }

//--------------------------------------------------------------------//
  void setView(int sw){
// \̐ݒ
    if(!waitsw){
      mapView=sw;
      clrsw=true;
      repaint();
    }
  }

//--------------------------------------------------------------------//
  public void update(Graphics g){
    if (dd!=null) {
      paintMap(g);
    }
    else if(message!=null){
      g.setColor(Color.white);
      g.drawString(message,10,40);
    }
  }

//--------------------------------------------------------------------//
  public void paint(Graphics g){
    if (dd!=null) {
      fx=getSize().width;
      fy=getSize().height;
      bgImage=createImage(fx,fy);
      bg=bgImage.getGraphics();
      x0=5;
      y0=dd.titleHeight(bg)+2;
      fxi=fx-2*x0;
      fyi=fy-y0-5;
      dd.set3DMesh(x0,y0,fxi,fyi,depth);
      dd.set2DMesh(fxi,fyi);
      paintMap(g);
    }
    else if(message!=null){
      g.setColor(Color.white);
      g.drawString(message,10,40);
    }
  }

//--------------------------------------------------------------------//
  void paintMap(Graphics g){
// }bv`
    if(clrsw){
      bg.setColor(Color.black);
      bg.fillRect(0,0,fx,fy);
      clrsw=false;
    }
    dd.drawTitle(bg,dd.flr[dd.mg[dd.pp].floor].floorColor
      	      	,dd.flr[dd.mg[dd.pp].floor].wallColor,fx);
    if(mapView==0){
      dd.draw3DMap(bg,x0,y0,fxi,fyi,depth);
    }
    else{
      dd.draw2DMap(bg,x0,y0);
    }
    if(waitsw){
      dd.drawMessage(bg,eventtype,x0,y0,fxi,fyi);
    }
    g.drawImage(bgImage,0,0,this);
  }
}

//--------------------------------------------------------------------//
// Rg[pl
class ControlPanel extends Panel
  implements ActionListener,ItemListener{
    dungeonPanel dpanel;
    Button forward=new Button("Forward");
    Button left=new Button("Left");
    Button right=new Button("Right");
    Button back=new Button("Back");
    Button yes=new Button("Yes");
    Button no=new Button("No");
    Choice viewmenu=new Choice();
    Panel panel1=new Panel();
    Panel panel2=new Panel();
    Panel panel21=new Panel();

//--------------------------------------------------------------------//
  public ControlPanel(dungeonPanel dpanel){
    this.dpanel=dpanel;
    setLayout(new GridLayout(3,1));

    panel1.setLayout(new GridLayout(3,3));
    panel1.add(new Canvas());
    forward.addActionListener(this);
    panel1.add(forward);
    panel1.add(new Canvas());
    left.addActionListener(this);
    panel1.add(left);
    panel1.add(new Canvas());
    right.addActionListener(this);
    panel1.add(right);
    panel1.add(new Canvas());
    back.addActionListener(this);
    panel1.add(back);
    panel1.add(new Canvas());
    add(panel1);

    panel2.setLayout(new GridLayout(3,1));
    panel2.add(new Canvas());
    panel21.setLayout(new GridLayout(1,2));
    yes.addActionListener(this);
    panel21.add(yes);
    no.addActionListener(this);
    panel21.add(no);
    panel2.add(panel21);

    viewmenu.addItem("3Dview");
    viewmenu.addItem("AutoMapping");
    viewmenu.select(0);
    viewmenu.addItemListener(this);
    panel2.add(viewmenu);
    add(panel2);
  }

//--------------------------------------------------------------------//
  public void actionPerformed(ActionEvent e){
// ړ{^
    if(e.getSource().equals(forward)){
      dpanel.goAhead();
    }
    else if(e.getSource().equals(left)){
      dpanel.turnLeft();
    }
    else if(e.getSource().equals(right)){
      dpanel.turnRight();
    }
    else if(e.getSource().equals(back)){
      dpanel.turnBack();
    }
    else if(e.getSource().equals(yes)){
      dpanel.eventOn();
    }
    else if(e.getSource().equals(no)){
      dpanel.eventOff();
    }
  }

//--------------------------------------------------------------------//
  public void itemStateChanged(ItemEvent e){
// _ύX
    String viewString=null;
    int sw;

    if(e.getSource() instanceof Choice){
      viewString=(String)e.getItem();
      if(viewString.equals("3Dview")) sw=0;
      else sw=1;
      dpanel.setView(sw);
    }
  }
}

//--------------------------------------------------------------------//
// _Wf[^
class Ddata{
  int fmax=100,emax=1000,nmax=500000; // KwECxgEǐ̏
  String title=null;                  // ^Cg
  Floor flr[]=new Floor[fmax];        // Kwf[^
  MapGrid mg[]=new MapGrid[nmax];     // }bv}Xڃf[^
  draw2D d2d;                         // 2D\NX
  draw3D d3d;                         // 3D\NX
  int wall[]=new int[nmax];           // Ǖf[^̒l
  Event event[]=new Event[emax];      // CxgNX
  int nfloor=0;                       // Kw
  int pp=0,direc=0;                   // ݂̈ʒuEp
  int msgx1,msgy1,msgx2,msgy2,msgx3;  // CxgbZ[W̕\ʒu
  String evMessage[]={"Start"         // CxgbZ[W
      	      	     ,"Goal  Conguratulation!!"
      	      	     ,"Upstairs is here. Do you go up?"
      	      	     ,"Downstairs is here. Do you go down?"};
  int ynswitch[]={0,0,1,1};           // CxgYes/No̗L

  Ddata(){}

  Ddata(InputStream is) throws IOException, FileFormatException{
    readGlobalData(is);
  }

//--------------------------------------------------------------------//
  void readGlobalData(InputStream is)
    throws IOException, FileFormatException{
// S̃f[^ǂݍ
    StreamTokenizer st=new StreamTokenizer
      	      	      (new BufferedReader(new InputStreamReader(is)));
    st.eolIsSignificant(true);
    readMapData(st);
    readEventData(st);
    is.close();
    if(st.ttype!=StreamTokenizer.TT_EOF)
      throw new FileFormatException(st.toString());
  }

//--------------------------------------------------------------------//
  void readMapData(StreamTokenizer st) throws IOException{
// }bvf[^ǂݍ
    String ftitle=null;
    int i,j,ii=0,jj,jjmax;
    int rgb[]=new int[3];
    int flabel=0,n1=0,n2=0,sumf=0,ofsetw,ofsetf,x=0,y=0;
    Color ceilColor=null,floorColor=null,wallColor=null
      	 ,swallColor=null,doorColor=null;
    boolean eof;

    if(st.nextToken()==StreamTokenizer.TT_WORD){
      title=st.sval;
    }
    if(st.nextToken()==StreamTokenizer.TT_NUMBER){
      nfloor=(int)st.nval;
    }
    for(i=0;i<nfloor;i++){
      ofsetw=ii;
      ofsetf=sumf;
      jj=0;
      while(st.nextToken()!=StreamTokenizer.TT_WORD);
      	ftitle=st.sval;
      while(st.nextToken()!=StreamTokenizer.TT_NUMBER);
      	flabel=(int)st.nval;
      while(st.nextToken()!=StreamTokenizer.TT_NUMBER);
      	n1=(int)st.nval;
      if(st.nextToken()==StreamTokenizer.TT_NUMBER)
      	n2=(int)st.nval;
      jjmax=2*n1*n2+n1+n2;
      sumf+=n1*n2;
      for(j=ofsetf;j<sumf;j++){
      	x=(j-ofsetf)%n1;
      	y=(j-ofsetf)/n1;
      	mg[j]=new MapGrid(x,y,i,ofsetw,n1);
      }

      eof=false;
      while(!eof){
      	switch (st.nextToken()) {
      	  default:
      	    eof=true;
      	  case StreamTokenizer.TT_EOL:
      	    break;
      	  case StreamTokenizer.TT_NUMBER:
      	    wall[ii]=(int)st.nval;
      	    ii++;
      	    jj++;
      	    if(jj==jjmax) eof=true;
      	    break;
      	  case StreamTokenizer.TT_WORD:
      	    if(st.sval.equals("ceil")){
      	      read3Ddata(st,rgb);
      	      ceilColor=new Color(rgb[0],rgb[1],rgb[2]);
      	    }
      	    else if(st.sval.equals("floor")){
      	      read3Ddata(st,rgb);
      	      floorColor=new Color(rgb[0],rgb[1],rgb[2]);
      	    }
      	    else if(st.sval.equals("wall")){
      	      read3Ddata(st,rgb);
      	      wallColor=new Color(rgb[0],rgb[1],rgb[2]);
      	      swallColor=new Color(rgb[0]/2,rgb[1]/2,rgb[2]/2);
      	    }
      	    else if(st.sval.equals("door")){
      	      read3Ddata(st,rgb);
      	      doorColor=new Color(rgb[0],rgb[1],rgb[2]);
      	    }
      	}
      }
      flr[i]=new Floor(ftitle,flabel,ceilColor,floorColor,wallColor
      	      	      ,swallColor,doorColor,n1,n2,ofsetw,ofsetf);
    }
  }

//--------------------------------------------------------------------//
  void readEventData(StreamTokenizer st) throws IOException{
// Cxgf[^ǂݍ
    int pt1=0,pt2=0,eventtype=0,movepoint=0,eventp=0;
    int xyz[]=new int[3];
    boolean eof;

    eof=false;
    event[0]=new Event(0);
    while(!eof){
      switch (st.nextToken()) {
      	default:
      	  eof=true;
      	case StreamTokenizer.TT_EOL:
      	  break;
      	case StreamTokenizer.TT_NUMBER:
      	  break;
      	case StreamTokenizer.TT_WORD:
      	  if(st.sval.equals("start")){                        // X^[g
      	    read3Ddata(st,xyz);
      	    pp=pointer(xyz[1],xyz[2],xyz[0]);
      	    mg[pp].Through();
      	  }
      	  else if(st.sval.equals("goal")){                    // S[
      	    eventp++;
      	    read3Ddata(st,xyz);
      	    pt1=pointer(xyz[1],xyz[2],xyz[0]);
      	    mg[pt1].setEvent(eventp);
      	    event[eventp]=new Event(1);
      	  }
      	  else if(st.sval.equals("stairs")){                  // Ki
      	    eventp+=2;
      	    read3Ddata(st,xyz);
      	    pt1=pointer(xyz[1],xyz[2],xyz[0]);
      	    read3Ddata(st,xyz);
      	    pt2=pointer(xyz[1],xyz[2],xyz[0]);
      	    mg[pt1].setEvent(eventp-1);
      	    mg[pt2].setEvent(eventp);
      	    event[eventp-1]=new Event(3,pt2);
      	    event[eventp]=new Event(2,pt1);
      	  }
      }
    }
  }

//--------------------------------------------------------------------//
  void read3Ddata(StreamTokenizer st,int xyz[]) throws IOException{
// Of[^ǂݍ
    if(st.nextToken()==StreamTokenizer.TT_NUMBER) xyz[0]=(int)st.nval;
    if(st.nextToken()==StreamTokenizer.TT_NUMBER) xyz[1]=(int)st.nval;
    if(st.nextToken()==StreamTokenizer.TT_NUMBER) xyz[2]=(int)st.nval;
  }

//--------------------------------------------------------------------//
  void set3DMesh(int x0,int y0,int fx,int fy,int depth){
// Rn}̃}Xڐݒ
    d3d=new draw3D(x0,y0,fx,fy,depth);
  }

//--------------------------------------------------------------------//
  void set2DMesh(int fx,int fy){
// 2DbVTCY̐ݒ
    int i;

    d2d=new draw2D();
    for(i=0;i<nfloor;i++){
      flr[i].setMeshSize(fx,fy);
    }
  }

//--------------------------------------------------------------------//
  int pointer(int x,int y,int z){
// ʒuϊ
    int i;

    for(i=0;i<nfloor;i++){
      if(flr[i].floor==z){
      	return flr[i].pointer(x-1,y-1);
      }
    }
    return 0;
  }

//--------------------------------------------------------------------//
  int goAhead(){
// OɈړ
    int nn1=flr[mg[pp].floor].n1,nn2=flr[mg[pp].floor].n2;

    switch(direc){
      case 0:                        // kɈړ
      	if(wall[mg[pp].nw]!=1){
      	  if(mg[pp].y==0)     pp+=nn1*(nn2-1);
      	  else                pp-=nn1;
      	}
      	break;
      case 1:                        // Ɉړ
      	if(wall[mg[pp].ew]!=1){
      	  if(mg[pp].x==nn1-1) pp-=nn1-1;
      	  else                pp++;
      	}
      	break;
      case 2:                        // Ɉړ
      	if(wall[mg[pp].sw]!=1){
      	  if(mg[pp].y==nn2-1) pp-=nn1*(nn2-1);
      	  else                pp+=nn1;
      	}
      	break;
      case 3:                        // Ɉړ
      	if(wall[mg[pp].ww]!=1){
      	  if(mg[pp].x==0)     pp+=nn1-1;
      	  else                pp--;
      	}
    }
    mg[pp].Through();

    return event[mg[pp].event].type;
  }

//--------------------------------------------------------------------//
  void turnRight(){
// E
    direc=(direc+1)%4;
  }

//--------------------------------------------------------------------//
  void turnLeft(){
// 
    direc=(direc+3)%4;
  }

//--------------------------------------------------------------------//
  void turnBack(){
// 
    direc=(direc+2)%4;
  }

//--------------------------------------------------------------------//
  int eventYN(int ev,int mx,int my){
// CxgYes/No
    int yn=-1;
    if(ynswitch[ev]==0){
      if(msgy1<=my && my<msgy2){
      	if(msgx1<=mx && mx<msgx2) yn=1;
      }
    }
    else{
      if(msgy1<=my && my<msgy2){
      	if(msgx1<=mx && mx<msgx3) yn=1;
      	else if(msgx3<=mx && mx<msgx2) yn=0;
      }
    }
    return yn;
  }

//--------------------------------------------------------------------//
  void eventAction(int evtype){
// Cxgs
    switch(evtype){
      default:
      	break;
// S[
      case 1:
      	break;
// Ki
      case 2:
      	pp=event[mg[pp].event].move;
      	mg[pp].Through();
      	break;
// Ki
      case 3:
      	pp=event[mg[pp].event].move;
      	mg[pp].Through();
      	break;
    }
  }

//--------------------------------------------------------------------//
  int titleHeight(Graphics g){
// }bv^Cg
    String titlebar=null;
    int sx,sy,gy=2,fontsize=18;
    Font font=new Font("Serif",Font.BOLD,fontsize);

// tHgݒ
    g.setFont(font);
    FontMetrics fm=g.getFontMetrics();
    sx=fm.stringWidth(titlebar);
    sy=fm.getHeight();

    return gy+sy+4;
  }

//--------------------------------------------------------------------//
  void drawTitle(Graphics g,Color boadColor,Color textColor,int fx){
// }bv^Cg\
    String titlebar=null;
    int sx,sy,gx,gy=2,fontsize=18;
    Font font=new Font("Serif",Font.BOLD,fontsize);

    if(title.equals("null")){
      titlebar=null;
    }
    else{
      titlebar=title+"";
    }
    if(flr[mg[pp].floor].floor>=0){
      titlebar+="  "+flr[mg[pp].floor].floor+"F";
    }
    else{
      titlebar+="  B"+(-flr[mg[pp].floor].floor)+"F";
    }
    if(flr[mg[pp].floor].title.equals("null")){}
    else{
      titlebar+="  "+flr[mg[pp].floor].title;
    }
    switch(direc){
      case 0:                        // k
      	titlebar+="  N";
      	break;
      case 1:                        // 
      	titlebar+="  E";
      	break;
      case 2:                        // 
      	titlebar+="  S";
      	break;
      case 3:                        // 
      	titlebar+="  W";
    }

// tHgݒ
    g.setFont(font);
    FontMetrics fm=g.getFontMetrics();
    sx=fm.stringWidth(titlebar);
    sy=fm.getHeight();
    gx=(fx-sx)/2-5;

// wiE\
    g.setColor(boadColor);
    g.fillRect(gx,gy,sx+10,sy+4);
    g.setColor(textColor);
    g.drawString(titlebar,gx+5,gy+sy);
  }

//--------------------------------------------------------------------//
  void draw3DMap(Graphics g,int x0,int y0,int fx,int fy,int depth){
// Rn}\
    int i,j,kk,kk2;
    int ww[]=new int[4];
    Color lineColor=flr[mg[pp].floor].floorColor;

    depth=Math.min(depth,d3d.depthmax-2);
    d3d.init3DMap(g,x0,y0,depth,flr[mg[pp].floor].ceilColor
      	      	 ,flr[mg[pp].floor].floorColor);
    for(i=depth;i>0;i--){
      for(j=-d3d.nw[i];j<=0;j++){
      	kk=viewPointer(i-1,j);
      	kk2=viewPointer(i-1,-j);
      	switch(direc){
      	  case 0:
      	    ww[0]=wall[mg[kk].nw];
      	    ww[1]=wall[mg[kk2].nw];
      	    ww[2]=wall[mg[kk].ww];
      	    ww[3]=wall[mg[kk2].ew];
      	    break;
      	  case 1:
      	    ww[0]=wall[mg[kk].ew];
      	    ww[1]=wall[mg[kk2].ew];
      	    ww[2]=wall[mg[kk].nw];
      	    ww[3]=wall[mg[kk2].sw];
      	    break;
      	  case 2:
      	    ww[0]=wall[mg[kk].sw];
      	    ww[1]=wall[mg[kk2].sw];
      	    ww[2]=wall[mg[kk].ew];
      	    ww[3]=wall[mg[kk2].ww];
      	    break;
      	  case 3:
      	    ww[0]=wall[mg[kk].ww];
      	    ww[1]=wall[mg[kk2].ww];
      	    ww[2]=wall[mg[kk].sw];
      	    ww[3]=wall[mg[kk2].nw];
      	}
      	d3d.draw3DMap(g,x0,y0,i,j,lineColor,flr[mg[pp].floor].wallColor
      	      	     ,flr[mg[pp].floor].swallColor,flr[mg[pp].floor].doorColor,ww);
      }
    }
  }

//--------------------------------------------------------------------//
  int viewPointer(int depth,int side){
// Έʒuɂw
    int px=0,py=0;

    px=mg[pp].x;
    py=mg[pp].y;
    switch(direc){
      case 0:                        // k
      	px+=side;
      	py-=depth;
      	break;
      case 1:                        // 
      	px+=depth;
      	py+=side;
      	break;
      case 2:                        // 
      	px-=side;
      	py+=depth;
      	break;
      case 3:                        // 
      	px-=depth;
      	py-=side;
    }
    if(px<0)                          px+=flr[mg[pp].floor].n1;
    else if(px>=flr[mg[pp].floor].n1) px-=flr[mg[pp].floor].n1;
    if(py<0)                          py+=flr[mg[pp].floor].n2;
    else if(py>=flr[mg[pp].floor].n2) py-=flr[mg[pp].floor].n2;
    return flr[mg[pp].floor].pointer(px,py);
  }

//--------------------------------------------------------------------//
  void draw2DMap(Graphics g,int x0,int y0){
// Qn}\
    int ks,ke,k,xx,yy;

    ks=flr[mg[pp].floor].ofsetf;
    ke=ks+flr[mg[pp].floor].n1*flr[mg[pp].floor].n2;
    for(k=ks;k<ke;k++){
      if(mg[k].through){
      	xx=x0+flr[mg[pp].floor].dmesh*mg[k].x;
      	yy=y0+flr[mg[pp].floor].dmesh*mg[k].y;
      	d2d.draw2DMesh(g,xx,yy,event,flr[mg[pp].floor],mg[k],wall);
      }
    }
    xx=x0+flr[mg[pp].floor].dmesh*mg[pp].x;
    yy=y0+flr[mg[pp].floor].dmesh*mg[pp].y;
    d2d.drawMe2D(g,xx,yy,flr[mg[pp].floor],direc);
  }

//--------------------------------------------------------------------//
  void drawMessage(Graphics g,int ev,int x0,int y0,int fx,int fy){
// CxgbZ[W\
    int sx,sy,fontsize=20;
    Font font=new Font("Serif",Font.BOLD,fontsize);

// tHgݒ
    g.setFont(font);
    FontMetrics fm=g.getFontMetrics();
    sx=fm.stringWidth(evMessage[ev]);
    sy=fm.getHeight();
    msgx1=x0+(fx-sx)/2-1;
    msgy1=y0+(fy-sy)/2-1;

// wiE\
    g.setColor(Color.white);
    g.fillRect(msgx1,msgy1,sx+2,sy+2);
    g.setColor(Color.black);
    g.drawRect(msgx1,msgy1,sx+2,sy+2);
    g.drawString(evMessage[ev],msgx1+1,msgy1+sy);
    if(ynswitch[ev]==1){
      sx=fm.stringWidth("Yes / No");
      msgx1=x0+(fx-sx)/2-1;
      msgy1+=sy+2;
      g.setColor(Color.white);
      g.fillRect(msgx1,msgy1,sx+2,sy+2);
      g.setColor(Color.black);
      g.drawRect(msgx1,msgy1,sx+2,sy+2);
      g.drawString("Yes / No",msgx1+1,msgy1+sy);
    }
    msgx2=msgx1+sx+2;
    msgy2=msgy1+sy+2;
    msgx3=msgx1+fm.stringWidth("Yes ")+2;
  }
}

//--------------------------------------------------------------------//
// Kwf[^
class Floor{
  String title;       // Kw^Cg
  int floor;          // Kwx
  Color ceilColor;    // VF
  Color floorColor;   // F
  Color wallColor;    // ǐF
  Color swallColor;   // ǁijF
  Color doorColor;    // F
  int n1;             // ̃}Xڂ̐
  int n2;             // c̃}Xڂ̐
  int dmesh;          // }Xڂ̑傫
  int ofsetw;         // f[^ItZbgiǁj
  int ofsetf;         // f[^ItZbgij

  Floor(String title,int floor,Color ceilColor,Color floorColor
       ,Color wallColor,Color swallColor,Color doorColor,int n1,int n2
       ,int ofsetw,int ofsetf){
    this.title=title;
    this.floor=floor;
    this.ceilColor=ceilColor;
    this.floorColor=floorColor;
    this.wallColor=wallColor;
    this.swallColor=swallColor;
    this.doorColor=doorColor;
    this.n1=n1;
    this.n2=n2;
    this.ofsetw=ofsetw;
    this.ofsetf=ofsetf;
  }

//--------------------------------------------------------------------//
  void setMeshSize(int fx,int fy){
// \TCY̐ݒ
    dmesh=Math.min(fx/n1,fy/n2);
  }

//--------------------------------------------------------------------//
  int pointer(int x,int y){
// ʒu|C^
    return ofsetf+n1*y+x;
  }
}

//--------------------------------------------------------------------//
// }bvP}X̃f[^
class MapGrid{
  boolean through=false;    // ʉߔ
  int event=0;              // Cxg
  int x=0,y=0,floor=0;      // Wʒu
  int ew=0,ww=0,nw=0,sw=0;  // k̕ǂ̃|C^

  MapGrid(int x,int y,int floor){
    this.x=x;
    this.y=y;
    this.floor=floor;
  }

  MapGrid(int x,int y,int floor,int ofsetw,int n1){
    this.x=x;
    this.y=y;
    this.floor=floor;
    nw=ofsetw+(2*n1+1)*y+x;
    ew=nw+n1+1;
    sw=nw+2*n1+1;
    ww=nw+n1;
  }

//--------------------------------------------------------------------//
  void Through(){
// |Cgʉ
    through=true;
  }

//--------------------------------------------------------------------//
  void setEvent(int event){
// Cxgݒ
    this.event=event;
  }
}

//--------------------------------------------------------------------//
// CxgNX
class Event{
  int type=0;      // Cxg
  int move=0;      // Cxgɂړʒu

  Event(int type){
    this.type=type;
  }

  Event(int type,int move){
    this.type=type;
    this.move=move;
  }
}

//--------------------------------------------------------------------//
// Q}bv\	
class draw2D{

  draw2D(){}

//--------------------------------------------------------------------//
  void draw2DMesh(Graphics g,int xx,int yy,Event event[],Floor flr
      	      	 ,MapGrid mg,int wall[]){
// Qn}P}X\
    int em,sx,sy,fontsize=flr.dmesh-2;
    Font font=new Font("Serif",Font.PLAIN,fontsize);

// 
    g.setColor(flr.floorColor);
    g.fillRect(xx,yy,flr.dmesh,flr.dmesh);
// ǁE
    if(wall[mg.nw]==1)      drawWall2D(g,xx,yy,0,flr);
    else if(wall[mg.nw]==2) drawDoor2D(g,xx,yy,0,flr);
    if(wall[mg.ww]==1)      drawWall2D(g,xx,yy,1,flr);
    else if(wall[mg.ww]==2) drawDoor2D(g,xx,yy,1,flr);
    if(wall[mg.ew]==1)      drawWall2D(g,xx+flr.dmesh,yy,1,flr);
    else if(wall[mg.ew]==2) drawDoor2D(g,xx+flr.dmesh,yy,1,flr);
    if(wall[mg.sw]==1)      drawWall2D(g,xx,yy+flr.dmesh,0,flr);
    else if(wall[mg.sw]==2) drawDoor2D(g,xx,yy+flr.dmesh,0,flr);

// Cxg
    em=mg.event;
    if(em!=0){
      g.setColor(flr.wallColor);
      FontMetrics fm=g.getFontMetrics();
      sx=xx+(flr.dmesh-fm.stringWidth("A"))/2;
      sy=yy+(flr.dmesh+fm.getHeight())/2;
      switch(event[em].type){
// S[
      	case 1:
      	  g.drawString("G",sx,sy);
      	  break;
// Ki
      	case 2:
      	  g.drawString("U",sx,sy);
      	  break;
// Ki
      	case 3:
      	  g.drawString("D",sx,sy);
      	  break;
      }
    }
  }

//--------------------------------------------------------------------//
  void drawWall2D(Graphics g,int x,int y,int hv,Floor flr){
// Qn}Ǖ\
    g.setColor(flr.wallColor);
    if(hv==0) g.drawLine(x,y,x+flr.dmesh,y);    // k
    else      g.drawLine(x,y,x,y+flr.dmesh);    // 
  }

//--------------------------------------------------------------------//
  void drawDoor2D(Graphics g,int x,int y,int hv,Floor flr){
// Qn}\
    int dw,xx,yy;

    dw=flr.dmesh/4;
    g.setColor(flr.wallColor);
    if(hv==0){                                  // k
      g.drawLine(x,y,x+dw,y);
      g.drawLine(x+flr.dmesh-dw,y,x+flr.dmesh,y);
      g.setColor(flr.doorColor);
      g.drawLine(x+dw,y,x+flr.dmesh-dw,y);
    }
    else{                                       // 
      g.drawLine(x,y,x,y+dw);
      g.drawLine(x,y+flr.dmesh-dw,x,y+flr.dmesh);
      g.setColor(flr.doorColor);
      g.drawLine(x,y+dw,x,y+flr.dmesh-dw);
    }
  }

//--------------------------------------------------------------------//
  void drawMe2D(Graphics g,int x0,int y0,Floor flr,int direc){
// Qn}ʒu\
    int k,dw1,dw2,dw3;
    int trix[]=new int[3];
    int triy[]=new int[3];

    for(k=0;k<3;k++){
      trix[k]=x0;
      triy[k]=y0;
    }
    dw1=flr.dmesh/4;
    dw2=flr.dmesh/2;
    dw3=flr.dmesh-dw1;
    g.setColor(flr.doorColor);
    switch(direc){
      case 0:                        // k
      	trix[0]+=dw2; triy[0]+=dw1;
      	trix[1]+=dw1; triy[1]+=dw3;
      	trix[2]+=dw3; triy[2]+=dw3;
      	break;
      case 1:                        // 
      	trix[0]+=dw3; triy[0]+=dw2;
      	trix[1]+=dw1; triy[1]+=dw1;
      	trix[2]+=dw1; triy[2]+=dw3;
      	break;
      case 2:                        // 
      	trix[0]+=dw2; triy[0]+=dw3;
      	trix[1]+=dw1; triy[1]+=dw1;
      	trix[2]+=dw3; triy[2]+=dw1;
      	break;
      case 3:                        // 
      	trix[0]+=dw1; triy[0]+=dw2;
      	trix[1]+=dw3; triy[1]+=dw1;
      	trix[2]+=dw3; triy[2]+=dw3;
    }
    g.fillPolygon(trix,triy,3);
  }
}

//--------------------------------------------------------------------//
// R}bv\	
class draw3D{
  int depthmax=10;                    // s̍ől
  int x1[]=new int[depthmax];         // 3D̕\ʒup[^
  int y1[]=new int[depthmax];
  int dx[]=new int[depthmax];
  int dy[]=new int[depthmax];
  int nw[]=new int[depthmax];
  int vwallx[]=new int[4];
  int vwally[]=new int[4];
  int vdoorx[]=new int[4];
  int vdoory[]=new int[4];
  int fx,fy;

  draw3D(int x0,int y0,int fx,int fy,int depth){
    set3DMesh(x0,y0,fx,fy,depth);
  }

//--------------------------------------------------------------------//
  void set3DMesh(int x0,int y0,int fx,int fy,int depth){
// Rn}̃}Xڐݒ
    int i;

    this.fx=fx;
    this.fy=fy;
    depth=Math.min(depth,depthmax-2);
    x1[0]=0;          y1[0]=0;
    dx[0]=fx;         dy[0]=fy;
    x1[1]=fx/10;      y1[1]=fy/10;
    dx[1]=fx-2*x1[1]; dy[1]=fy-2*y1[1];
    nw[0]=0;          nw[1]=1;
    for(i=2;i<=depth+1;i++){
      x1[i]=(fx/2-x1[i-1])/3+x1[i-1];
      y1[i]=(fy/2-y1[i-1])/3+y1[i-1];
      dx[i]=fx-2*x1[i];
      dy[i]=fy-2*y1[i];
      nw[i]=(fx/dx[i]+1)/2;
    }
  }

//--------------------------------------------------------------------//
  void draw3DMap(Graphics g,int x0,int y0,int depth,int x
      	      	,Color lineColor,Color wallColor,Color swallColor
      	      	,Color doorColor,int ww[]){
// Rn}\
    int xx[]=new int[2];
    int dxx,i;

    xx[0]=x1[depth]+dx[depth]*x;
    xx[1]=x1[depth]-dx[depth]*x;
    dxx=dx[depth];
    if(xx[0]<0){
      dxx+=xx[0];
      xx[0]=0;
      xx[1]=fx-dxx;
    }
    for(i=0;i<2;i++){
      if(ww[i]==1){
      	draw3DWall(g,wallColor,lineColor,x0+xx[i],y0+y1[depth],dxx,dy[depth]);
      }
      else if(ww[i]==2){
      	draw3DWall(g,wallColor,lineColor,x0+xx[i],y0+y1[depth],dxx,dy[depth]);
      	draw3DDoor(g,doorColor,lineColor,x0,y0,xx[i],depth,x);
      }
    }
    if(nw[depth]+x!=0 && nw[depth-1]+x>=0){
      xx[0]=x;
      xx[1]=1-x;
      for(i=0;i<2;i++){
      	make3DSideWall(depth,xx[i],x0,x0+fx,y0,fy);
      	if(ww[i+2]==1){
      	  draw3DSideWall(g,swallColor,lineColor,vwallx,vwally);
      	}
      	else if(ww[i+2]==2){
      	  draw3DSideWall(g,swallColor,lineColor,vwallx,vwally);
      	  make3DSideDoor(depth-1,xx[i],x0,x0+fx,y0);
      	  draw3DSideWall(g,doorColor,lineColor,vdoorx,vdoory);
      	}
      }
    }
  }

//--------------------------------------------------------------------//
  void init3DMap(Graphics g,int x0,int y0,int depth,Color ceilColor
      	      	,Color floorColor){
// Rn}\

    g.setColor(ceilColor);
    g.fillRect(x0,y0,fx,y1[depth]);
    g.setColor(Color.black);
    g.fillRect(x0,y0+y1[depth],fx,fy-2*y1[depth]);
    g.setColor(floorColor);
    g.fillRect(x0,y0+fy-y1[depth],fx,y1[depth]);
  }

//--------------------------------------------------------------------//
  void make3DSideWall(int i,int j,int x0,int xmax,int y0,int ymax){
// Ǖ\Wf[^쐬
    vwally[0]=y0+y1[i-1];
    vwally[1]=y0+y1[i];
    vwally[2]=vwally[1]+dy[i];
    vwally[3]=vwally[0]+dy[i-1];
    vwallx[0]=x0+x1[i-1]+dx[i-1]*j;
    vwallx[1]=x0+x1[i]+dx[i]*j;
    if(vwallx[0]<x0){
      vwally[0]+=(vwally[1]-vwally[0])*(x0-vwallx[0])
      	      	/(vwallx[1]-vwallx[0]);
      vwally[3]=2*y0+ymax-vwally[0];
      vwallx[0]=x0;
    }
    else if(vwallx[0]>xmax){
      vwally[0]+=(vwally[1]-vwally[0])*(xmax-vwallx[0])
      	      	/(vwallx[1]-vwallx[0]);
      vwally[3]=2*y0+ymax-vwally[0];
      vwallx[0]=xmax;
    }
    vwallx[2]=vwallx[1];
    vwallx[3]=vwallx[0];
  }

//--------------------------------------------------------------------//
  void make3DSideDoor(int i,int j,int xmin,int xmax,int ymin){
// \Wf[^쐬
    int ddx;

    vwallx[0]=xmin+x1[i]+dx[i]*j;
    vwally[0]=ymin+y1[i];
    vwally[3]=vwally[0]+dy[i];
    if(i==0){
      vdoorx[0]=vwallx[0];
      vdoorx[1]=(vwallx[0]+vwallx[1])/2;
      vdoory[0]=vwally[0];
      vdoory[1]=(vwally[0]+vwally[1])/2;
      vdoory[2]=(vwally[3]+vwally[2])/2;
      vdoory[3]=vwally[3];
    }
    else{
      vdoorx[0]=(3*vwallx[0]+vwallx[1])/4;
      vdoorx[1]=(vwallx[0]+3*vwallx[1])/4;
      vdoory[0]=(3*vwally[0]+vwally[1])/4;
      vdoory[1]=(vwally[0]+3*vwally[1])/4;
      vdoory[2]=(vwally[3]+3*vwally[2])/4;
      vdoory[3]=(3*vwally[3]+vwally[2])/4;
    }
    vdoory[0]+=(vdoory[3]-vdoory[0])/5;
    vdoory[1]+=(vdoory[2]-vdoory[1])/5;
    ddx=vdoorx[1]-vdoorx[0];
    if(vdoorx[0]<xmin){
      vdoory[0]+=(vdoory[1]-vdoory[0])*(xmin-vdoorx[0])/ddx;
      vdoory[3]+=(vdoory[2]-vdoory[3])*(xmin-vdoorx[0])/ddx;
      vdoorx[0]=xmin;
    }
    else if(vdoorx[0]>xmax){
      vdoory[0]+=(vdoory[1]-vdoory[0])*(xmax-vdoorx[0])/ddx;
      vdoory[3]+=(vdoory[2]-vdoory[3])*(xmax-vdoorx[0])/ddx;
      vdoorx[0]=xmax;
    }
    vdoorx[2]=vdoorx[1];
    vdoorx[3]=vdoorx[0];
  }

//--------------------------------------------------------------------//
  void draw3DWall(Graphics g,Color wallColor,Color lineColor
      	      	 ,int x0,int y0,int xx,int yy){
// OǕ`
    g.setColor(wallColor);
    g.fillRect(x0,y0,xx,yy);
    g.setColor(lineColor);
    g.drawRect(x0,y0,xx,yy);
  }

//--------------------------------------------------------------------//
  void draw3DSideWall(Graphics g,Color wallColor,Color lineColor
      	      	     ,int xx[],int yy[]){
// Ǖ`
    g.setColor(wallColor);
    g.fillPolygon(xx,yy,4);
    g.setColor(lineColor);
    g.drawPolygon(xx,yy,4);
  }

//--------------------------------------------------------------------//
  void draw3DDoor(Graphics g,Color wallColor,Color lineColor
      	      	 ,int x0,int y0,int xx0,int i,int j){
// O`
    int drx0,drx,dry0;

    drx0=dx[i]/4;
    drx=dx[i]-2*drx0;
    dry0=dy[i]/5;
    if(xx0==0){
      drx0+=x1[i]+dx[i]*j;
      if(drx0<0){
      	drx+=drx0;
      	drx0=0;
      }
    }
    else if(xx0+drx0+drx>fx){
      drx=fx-xx0-drx0;
    }
    draw3DWall(g,wallColor,lineColor,x0+xx0+drx0,y0+y1[i]+dry0
      	      ,drx,dy[i]-dry0);
  }
}
